#!/bin/sh

# Autor - Jan Ondrej "SAL" (ondrejj@salstar.shadow.sk)
# Modifikacie pre Debian hamm - Miroslav Vasko (vasko@debian.cz)

FONTS_DIR=/usr/X11R6/lib/X11/fonts/iso8859-2/Type1

echo ""
echo "Zadajte adresar, kde ste instalovali SO 5.0 (Enter=/usr/local/Office50)"
read STAR_OFFICE_ROOT

if [ "$STAR_OFFICE_ROOT" == "" ]
then
  STAR_OFFICE_ROOT=/usr/local/Office50
fi

# Pozri, ci su fonty nainstalovane
if [ -d /usr/X11R6/lib/X11/fonts/iso8859-2/Type1 ]
then
  :
else
  # Najprv treba nainstalovat fonty
  echo ""
  echo ""
  echo "Chyba: najprv nainstalujte balik x11fonts-ult1mo-beta_1.0-4_all.deb !!!"
  echo ""
  echo ""
  exit 1
fi

# vyrob fonts.dir
echo "Pripravujem fonty..."
if [ -f /usr/X11R6/lib/X11/fonts/iso8859-2/Type1/fots.dir ]
then
  :
else
  cp ./bin/type1inst /usr/X11R6/lib/X11/fonts/iso8859-2/Type1/
  (cd /usr/X11R6/lib/X11/fonts/iso8859-2/Type1/ ; ./type1inst --quiet)
  rm /usr/X11R6/lib/X11/fonts/iso8859-2/Type1/type1inst
fi

XP3_DIR=$STAR_OFFICE_ROOT/xp3

if [ -f $XP3_DIR/pclstd.fonts.old ]
then
  :
else
  cp $XP3_DIR/pclstd.fonts $XP3_DIR/pclstd.fonts.old
fi

if [ -e $XP3_DIR/psstd.fonts.il2 ]; then
  echo "Zmeny uz boli raz prevedene! Nemozno previest znova."
  echo "Ak je nejaky problem a predsa to chcete, tak zmazte subor"
  echo "  $XP3_DIR/psstd.fonts.il2"
  echo "a zmazte v subore psstd.fonts riadky podla navodu v README"
  exit 1
fi

if [ -e $FONTS_DIR/AFM ]; then
  AFM_DIR=$FONTS_DIR/AFM
else
  AFM_DIR=$FONTS_DIR
fi

# Link AFM files.
echo "Linkujem fonty..."
for AFM_FILE in $AFM_DIR/*
do
  # ln -sf $AFM_DIR/*.[aA][fF][mM] $XP3_DIR/fontmetrics/afm
  RES=`echo $AFM_FILE | grep "\.afm$"`
  if [ "$RES" == "" ]
  then
    :
  else
    ln -sf $AFM_FILE $XP3_DIR/fontmetrics/afm
  fi
done

# Link PFB files.
for PFB_FILE in $FONTS_DIR/*
do
  # ln -sf $FONTS_DIR/*.[pP][fF][bB] $XP3_DIR/pssoftfonts
  RES=`echo $PFB_FILE | grep "\.pfb$"`
  if [ "$RES" == "" ]
  then
    :
  else
    ln -sf $PFB_FILE $XP3_DIR/pssoftfonts
  fi
done

echo "Upravujem konfiguracne subory..."
grep "\.pf" $FONTS_DIR/fonts.dir \
  | sed -e 's/\.pfb /, /g' -e 's/-0-0-0-0-/-%d-%d-%d-%d-/g' \
  > $XP3_DIR/psstd.fonts.il2

echo "" >> $XP3_DIR/psstd.fonts
echo "" >> $XP3_DIR/psstd.fonts
echo "# Pridal sk-so50:" >> $XP3_DIR/psstd.fonts
echo "" >> $XP3_DIR/psstd.fonts
echo "" >> $XP3_DIR/psstd.fonts
cat $XP3_DIR/psstd.fonts.il2 >> $XP3_DIR/psstd.fonts

# Nalinkuj PCL fonts do PS fonts
rm $XP3_DIR/pclstd.fonts
ln -sf $XP3_DIR/psstd.fonts $XP3_DIR/pclstd.fonts

echo ""
echo "Hotovo."
echo ""
