#!/usr/bin/python

import string
import sys
import re

packages={}

err_nomore_pkg="nomore_pkg"
err_diff_names="diff_names"
err_missing="missing"

class Package:
	REGEX_PACKAGE_NAME='(?s)Package: (.*?)\n'
	REGEX_PACKAGE_DESC='(?s)Description:((?: .*?\n)+)'
	REGEX_PACKAGE_VER ='(?s)Version: (.*?)\n'

	__compre_name = re.compile(REGEX_PACKAGE_NAME)
	__compre_ver  = re.compile(REGEX_PACKAGE_VER)
	__compre_desc = re.compile(REGEX_PACKAGE_DESC)

	def __init__(self,data_string):
		self.__data=data_string	
		self.__searchre_name = self.__compre_name.search(self.__data)
		self.__searchre_ver  = self.__compre_ver.search (self.__data)
		self.__searchre_desc = self.__compre_desc.search(self.__data)
	def name(self):
		if self.__searchre_name:
			return self.__searchre_name.group(1)
		else: 
			return None 
    	def version(self):
 		if self.__searchre_ver:
			return self.__searchre_ver.group(1)
		else: 
			return None 
     	def description(self):
 		if self.__searchre_desc:
			return self.__searchre_desc.group(1)
		else: 
			return None
	def errdump(self):
		sys.stderr.write(self.__data)
			   
def readpackage(file):
	s=''
	while 1:
        	line=file.readline()
        	if not string.strip(line):
			if string.strip(s):
				return Package(s)
			elif not line:
				return None
			else:
				s=''
		else:
		   s=s+line

if __name__ == '__main__':
	try:
		forg = open(sys.argv[1:2][0], 'r')
		ftra = open(sys.argv[2:3][0], 'r')
		while 1:
			ptra=readpackage(ftra)
			porg=readpackage(forg)
			if ptra==None and porg==None:
				raise err_nomore_pkg
			elif ptra==None or porg==None:
				raise err_missing
			elif ptra.name()!=porg.name() or ptra.version()!=porg.version():
				sys.stderr.write('<abort: diffrent packages>\n')
				porg.errdump()
				sys.stderr.write('------------------\n')
				ptra.errdump()
				raise err_diff_names
			"""sys.stdout.write('Package: '+porg.name()+'\n')
			if porg.version()==None:
				raise err_missing
			sys.stdout.write('Version: '+porg.version()+'\n')
			sys.stdout.write('Description: '+ptra.description())
			sys.stdout.write('\n')"""
	
	except IOError, msg:
		sys.stderr.write('<abort: input problem>\n')
	except err_missing:
		sys.stderr.write('<abort: missing package>\n')
	except err_diff_names:
	 	pass	
	except err_nomore_pkg:
		pass

