#!/usr/bin/python

import string
import sys
import re

err_missing="missing"

class Package:
	REGEX_PACKAGE_NAME='(?s)Package: (.*?)\n'
	REGEX_PACKAGE_DESC='(?s)Description:((?: .*?\n)+)'
	REGEX_PACKAGE_VER ='(?s)Version: (.*?)\n'

	__compre_name = re.compile(REGEX_PACKAGE_NAME)
	__compre_ver  = re.compile(REGEX_PACKAGE_VER)
	__compre_desc = re.compile(REGEX_PACKAGE_DESC)

	def __init__(self,data_string):
		self.__data=data_string
		self.__searchre_name = self.__compre_name.search(self.__data)
		self.__searchre_ver  = self.__compre_ver.search (self.__data)
		self.__searchre_desc = self.__compre_desc.search(self.__data)
	def name(self):
		if self.__searchre_name:
			return self.__searchre_name.group(1)
		else: 
			return None 
    	def version(self):
 		if self.__searchre_ver:
			return self.__searchre_ver.group(1)
		else: 
			return None 
     	def description(self):
 		if self.__searchre_desc:
			return self.__searchre_desc.group(1)
		else: 
			return None
	def write(self):
		sys.stdout.write(self.__data)

	def errdump(self):
		sys.stderr.write(self.__data)

def readpackage(file):
	s=''
	while 1:
        	line=file.readline()
        	if not string.strip(line):
			if string.strip(s):
				return Package(s)
			elif not line:
				return None
			else:
				s=''
		else:
		   s=s+line

def readpackages(file):
	list = []
	while 1:
		p=readpackage(file)
		if not p:
			return list
		if not (p.name() and p.version() and p.description()):
			p.errdump()
			raise err_missing
		list.append((p.name(),p.version(),p))

if __name__ == '__main__':
	try:
		forg = open(sys.argv[1:2][0], 'r')
		packages=readpackages(forg)
		packages.sort()
		for c in packages:
			(n,v,p)=c
			p.write()
			sys.stdout.write('\n')
	except IOError, msg:
		sys.stderr.write('<abort: input problem>\n')
	except err_missing:
		sys.stderr.write('<abort: missing one of name, version, description part>\n')
										


