#!/usr/bin/python

import string
import sys
import re

err_nomore_pkg="nomore_pkg"
err_diff_names='<abort: diffrent package names>\n'
err_missing   ='<abort: missing one of name, version, description part>\n'

class Package:
	REGEX_PACKAGE_NAME='(?s)Package: (.*?)\n'
	REGEX_PACKAGE_DESC='(?s)Description:((?: .*?\n)+)'

	__compre_name = re.compile(REGEX_PACKAGE_NAME)
	__compre_desc = re.compile(REGEX_PACKAGE_DESC)

	def __init__(self,data_string):
		self.__data=data_string
		self.__tran=''
		self.__searchre_name = self.__compre_name.search(self.__data)
		self.__searchre_desc = self.__compre_desc.search(self.__data)
	def name(self):
		if self.__searchre_name:
			return self.__searchre_name.group(1)
		else: 
			return None 
     	def description(self):
 		if self.__searchre_desc:
			return self.__searchre_desc.group(1)
		else: 
			return None
	def add_partial_translation(self,tran):
		self.__tran = self.__tran +tran

	def write(self):	
		sys.stdout.write(self.__data)
		sys.stdout.write(self.__tran)

	def errdump(self):
		sys.stderr.write(self.__data)

def readpackage(file):
	s=''
	while 1:
        	line=file.readline()
        	if not string.strip(line):
			if string.strip(s):
				return Package(s)
			elif not line:
				return None
			else:
				s=''
		else:
		   s=s+line

def readpackages(file):
	i=1
	hash = {}
	while 1:
		p=readpackage(file)
		if not p:
			return hash
		if not (p.name() and p.description()):
			p.errdump()
			raise err_missing
		key=p.name()
		if hash.has_key(key):
			ep= p.name()+' '+p.version()
			sys.stderr.write('<warning: '+ep+' more than once\n')
		else:
		    hash[key]=(i,p)
		    i=i+1

if __name__ == '__main__':
	try:
		sys.stderr.write('reading what to translate...\n')
		forg = open(sys.argv[1:2][0], 'r')
		packages=readpackages(forg)
		
		sys.stderr.write('searching for already translated...\n')
		flang1=open(sys.argv[2:3][0], 'r')
		flang2=open(sys.argv[3:4][0], 'r')
		try:
			while 1:
				p1=readpackage(flang1)
				p2=readpackage(flang2)
				if not p1 and not p2:
					raise err_nomore_pkg
				if not p1 or not p2:
					raise err_missing
				if not (p1.name() and p1.description()):
					p1.errdump()
					raise err_missing
				if not (p2.name() and p2.description()):
					p2.errdump()
					raise err_missing
				elif p1.name()!=p2.name():
					p1.errdump()
					sys.stderr.write('-'*20+'\n')
					p2.errdump()
					raise err_diff_names
				if packages.has_key(p1.name()):
					(i,p)=packages[p1.name()]
					if p.description()==p1.description():
						del packages[p1.name()]
				    
		except err_nomore_pkg:
			pass
		
		sys.stderr.write('flushing results...\n')
		list=packages.values()
		list.sort()
		for c in list:
			(n,p)=c
			p.write()
			sys.stdout.write('\n')
		sys.stderr.write('done.\a\n')
		

	except IOError, msg:
		sys.stderr.write('<abort: input problem>\n')
	except err_missing:
		sys.stderr.write(err_missing)
	except err_diff_names:
		sys.stderr.write(err_diff_names)
								


